#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2100five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 2100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five21004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five21004xi = {
                1: '-1014x1098y1474z',
                2: '-1026x1724y619z',
                3: '-1027x278y1810z',
                4: '-1057x228y1799z',
                5: '-1068x1186y1364z',
                6: '-1080x1054y1459z',
                7: '-1086x175y1788z',
                8: '-109x12y2097z',
                9: '-1111x120y1777z',
                10: '-1118x1673y599z',
                11: '-1134x63y1766z',
                12: '-1138x1138y1348z',
                13: '-1145x1006y1444z',
                14: '-1153x3y1754z',
                15: '-1206x1086y1332z',
                16: '-1207x953y1428z',
                17: '-1208x1616y578z',
                18: '-1267x897y1413z',
                19: '-1271x1029y1315z',
                20: '-1295x1555y558z',
                21: '-131x7y2095z',
                22: '-1324x837y1397z',
                23: '-1334x969y1299z',
                24: '-135x649y1992z',
                25: '-1378x1489y538z',
                26: '-1379x773y1381z',
                27: '-1394x905y1282z',
                28: '-1429x706y1366z',
                29: '-1450x837y1266z',
                30: '-1458x1419y518z',
                31: '-1477x636y1350z',
                32: '-148x1413y1545z',
                33: '-1503x766y1249z',
                34: '-1521x562y1333z',
                35: '-152x0y2094z',
                36: '-1534x1344y497z',
                37: '-1553x691y1232z',
                38: '-1561x486y1317z',
                39: '-1597x406y1301z',
                40: '-1598x613y1215z',
                41: '-1606x1265y477z',
                42: '-1629x325y1284z',
                43: '-1640x532y1198z',
                44: '-1656x241y1267z',
                45: '-1674x1182y456z',
                46: '-1677x449y1180z',
                47: '-1679x155y1251z',
                48: '-1710x363y1163z',
                49: '-1737x1095y436z',
                50: '-1738x275y1145z',
                51: '-174x660y1985z',
                52: '-1761x185y1128z',
                53: '-1778x71y1293z',
                54: '-1779x93y1110z',
                55: '-1793x0y1092z',
                56: '-1796x1004y415z',
                57: '-1850x911y395z',
                58: '-1898x814y374z',
                59: '-1942x715y353z',
                60: '-1980x613y333z',
                61: '-2012x510y312z',
                62: '-2039x404y291z',
                63: '-2061x297y270z',
                64: '-2076x189y249z',
                65: '-2085x81y229z',
                66: '-215x669y1978z',
                67: '-223x1305y1629z',
                68: '-224x1419y1531z',
                69: '-230x1937y777z',
                70: '-24x8y2099z',
                71: '-256x675y1971z',
                72: '-294x1307y1616z',
                73: '-299x679y1964z',
                74: '-301x1420y1516z',
                75: '-332x1929y758z',
                76: '-343x680y1956z',
                77: '-367x1306y1602z',
                78: '-379x1417y1502z',
                79: '-388x678y1949z',
                80: '-434x1917y738z',
                81: '-434x673y1941z',
                82: '-440x1300y1589z',
                83: '-458x1409y1487z',
                84: '-45x12y2099z',
                85: '-480x665y1933z',
                86: '-4x1y2099z',
                87: '-513x1290y1575z',
                88: '-526x654y1924z',
                89: '-536x1397y1472z',
                90: '-536x1898y718z',
                91: '-572x640y1916z',
                92: '-587x1275y1561z',
                93: '-614x1381y1457z',
                94: '-619x622y1907z',
                95: '-637x1874y698z',
                96: '-63x620y2005z',
                97: '-660x1257y1547z',
                98: '-664x602y1898z',
                99: '-66x14y2098z',
                100: '-692x1359y1442z',
                101: '-710x578y1889z',
                102: '-732x1234y1532z',
                103: '-737x1845y679z',
                104: '-754x552y1880z',
                105: '-770x1334y1427z',
                106: '-798x522y1870z',
                107: '-805x1206y1518z',
                108: '-835x1810y659z',
                109: '-840x488y1861z',
                110: '-846x1303y1411z',
                111: '-876x1175y1503z',
                112: '-881x452y1851z',
                113: '-88x14y2098z',
                114: '-920x413y1841z',
                115: '-922x1269y1396z',
                116: '-932x1769y639z',
                117: '-945x1139y1489z',
                118: '-958x371y1831z',
                119: '-98x635y1998z',
                120: '-993x326y1820z',
                121: '-996x1229y1380z'}

#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2100five4xi" usage = "target function for charge21004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire2100five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2100FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2100FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2100FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2100FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2100FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five21004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2100FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2100FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2100FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five21004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five21004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2100FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2100FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2100FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2100five4xi.py                             
# -------------------------------------------------------------------------------------------------                